#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_PUSH_DESCRIPTOR_SPEC_VERSION")]
pub const KHR_PUSH_DESCRIPTOR_SPEC_VERSION: u32 = 2;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_PUSH_DESCRIPTOR_EXTENSION_NAME")]
pub const KHR_PUSH_DESCRIPTOR_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_push_descriptor");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_PUSH_DESCRIPTOR_SET_KHR: *const std::os::raw::c_char = crate::cstr!("vkCmdPushDescriptorSetKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_PUSH_DESCRIPTOR_SET_WITH_TEMPLATE_KHR: *const std::os::raw::c_char = crate::cstr!("vkCmdPushDescriptorSetWithTemplateKHR");
#[doc = "Provided by [`crate::extensions::khr_push_descriptor`]"]
impl crate::vk1_0::DescriptorSetLayoutCreateFlagBits {
    pub const PUSH_DESCRIPTOR_KHR: Self = Self(1);
}
#[doc = "Provided by [`crate::extensions::khr_push_descriptor`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_PUSH_DESCRIPTOR_PROPERTIES_KHR: Self = Self(1000080000);
}
#[doc = "Provided by [`crate::extensions::khr_push_descriptor`]"]
impl crate::vk1_1::DescriptorUpdateTemplateType {
    pub const PUSH_DESCRIPTORS_KHR: Self = Self(1);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdPushDescriptorSetKHR.html)) · Function <br/> vkCmdPushDescriptorSetKHR - Pushes descriptor updates into a command buffer\n[](#_c_specification)C Specification\n----------\n\nIn addition to allocating descriptor sets and binding them to a command\nbuffer, an application **can** record descriptor updates into the command\nbuffer.\n\nTo push descriptor updates into a command buffer, call:\n\n```\n// Provided by VK_KHR_push_descriptor\nvoid vkCmdPushDescriptorSetKHR(\n    VkCommandBuffer                             commandBuffer,\n    VkPipelineBindPoint                         pipelineBindPoint,\n    VkPipelineLayout                            layout,\n    uint32_t                                    set,\n    uint32_t                                    descriptorWriteCount,\n    const VkWriteDescriptorSet*                 pDescriptorWrites);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer that the descriptors will be\n  recorded in.\n\n* [`Self::pipeline_bind_point`] is a [`crate::vk::PipelineBindPoint`] indicating the\n  type of the pipeline that will use the descriptors.\n  There is a separate set of push descriptor bindings for each pipeline\n  type, so binding one does not disturb the others.\n\n* [`Self::layout`] is a [`crate::vk::PipelineLayout`] object used to program the\n  bindings.\n\n* [`Self::set`] is the set number of the descriptor set in the pipeline layout\n  that will be updated.\n\n* [`Self::descriptor_write_count`] is the number of elements in the[`Self::p_descriptor_writes`] array.\n\n* [`Self::p_descriptor_writes`] is a pointer to an array of[`crate::vk::WriteDescriptorSet`] structures describing the descriptors to be\n  updated.\n[](#_description)Description\n----------\n\n*Push descriptors* are a small bank of descriptors whose storage is\ninternally managed by the command buffer rather than being written into a\ndescriptor set and later bound to a command buffer.\nPush descriptors allow for incremental updates of descriptors without\nmanaging the lifetime of descriptor sets.\n\nWhen a command buffer begins recording, all push descriptors are undefined.\nPush descriptors **can** be updated incrementally and cause shaders to use the\nupdated descriptors for subsequent [bound\npipeline commands](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#pipeline-bindpoint-commands) with the pipeline type set by [`Self::pipeline_bind_point`]until the descriptor is overwritten, or else until the set is disturbed as\ndescribed in [Pipeline Layout\nCompatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#descriptorsets-compatibility).\nWhen the set is disturbed or push descriptors with a different descriptor\nset layout are set, all push descriptors are undefined.\n\nPush descriptors that are [statically used](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#shaders-staticuse) by a\npipeline **must** not be undefined at the time that a drawing or dispatching\ncommand is recorded to execute using that pipeline.\nThis includes immutable sampler descriptors, which **must** be pushed before\nthey are accessed by a pipeline (the immutable samplers are pushed, rather\nthan the samplers in [`Self::p_descriptor_writes`]).\nPush descriptors that are not statically used **can** remain undefined.\n\nPush descriptors do not use dynamic offsets.\nInstead, the corresponding non-dynamic descriptor types **can** be used and the`offset` member of [`crate::vk::DescriptorBufferInfo`] **can** be changed each\ntime the descriptor is written.\n\nEach element of [`Self::p_descriptor_writes`] is interpreted as in[`crate::vk::WriteDescriptorSet`], except the `dstSet` member is ignored.\n\nTo push an immutable sampler, use a [`crate::vk::WriteDescriptorSet`] with`dstBinding` and `dstArrayElement` selecting the immutable sampler’s\nbinding.\nIf the descriptor type is [`crate::vk::DescriptorType::SAMPLER`], the`pImageInfo` parameter is ignored and the immutable sampler is taken\nfrom the push descriptor set layout in the pipeline layout.\nIf the descriptor type is [`crate::vk::DescriptorType::COMBINED_IMAGE_SAMPLER`],\nthe `sampler` member of the `pImageInfo` parameter is ignored and\nthe immutable sampler is taken from the push descriptor set layout in the\npipeline layout.\n\nValid Usage\n\n* []() VUID-vkCmdPushDescriptorSetKHR-pipelineBindPoint-00363  \n  [`Self::pipeline_bind_point`] **must** be supported by the [`Self::command_buffer`]’s\n  parent [`crate::vk::CommandPool`]’s queue family\n\n* []() VUID-vkCmdPushDescriptorSetKHR-set-00364  \n  [`Self::set`] **must** be less than[`crate::vk::PipelineLayoutCreateInfo::set_layout_count`] provided when[`Self::layout`] was created\n\n* []() VUID-vkCmdPushDescriptorSetKHR-set-00365  \n  [`Self::set`] **must** be the unique set number in the pipeline layout that\n  uses a descriptor set layout that was created with[`crate::vk::DescriptorSetLayoutCreateFlagBits::PUSH_DESCRIPTOR_KHR`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdPushDescriptorSetKHR-pipelineBindPoint-parameter  \n  [`Self::pipeline_bind_point`] **must** be a valid [`crate::vk::PipelineBindPoint`] value\n\n* []() VUID-vkCmdPushDescriptorSetKHR-layout-parameter  \n  [`Self::layout`] **must** be a valid [`crate::vk::PipelineLayout`] handle\n\n* []() VUID-vkCmdPushDescriptorSetKHR-pDescriptorWrites-parameter  \n  [`Self::p_descriptor_writes`] **must** be a valid pointer to an array of [`Self::descriptor_write_count`] valid [`crate::vk::WriteDescriptorSet`] structures\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics, or compute operations\n\n* []() VUID-vkCmdPushDescriptorSetKHR-descriptorWriteCount-arraylength  \n  [`Self::descriptor_write_count`] **must** be greater than `0`\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commonparent  \n   Both of [`Self::command_buffer`], and [`Self::layout`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Device`]\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |         Graphics  <br/>Compute          |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`], [`crate::vk::PipelineBindPoint`], [`crate::vk::PipelineLayout`], [`crate::vk::WriteDescriptorSet`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdPushDescriptorSetKHR = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer, pipeline_bind_point: crate::vk1_0::PipelineBindPoint, layout: crate::vk1_0::PipelineLayout, set: u32, descriptor_write_count: u32, p_descriptor_writes: *const crate::vk1_0::WriteDescriptorSet) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdPushDescriptorSetWithTemplateKHR.html)) · Function <br/> vkCmdPushDescriptorSetWithTemplateKHR - Pushes descriptor updates into a command buffer using a descriptor update template\n[](#_c_specification)C Specification\n----------\n\nIt is also possible to use a descriptor update template to specify the push\ndescriptors to update.\nTo do so, call:\n\n```\n// Provided by VK_KHR_push_descriptor with VK_VERSION_1_1, VK_KHR_push_descriptor with VK_KHR_descriptor_update_template, VK_KHR_descriptor_update_template with VK_KHR_push_descriptor\nvoid vkCmdPushDescriptorSetWithTemplateKHR(\n    VkCommandBuffer                             commandBuffer,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    VkPipelineLayout                            layout,\n    uint32_t                                    set,\n    const void*                                 pData);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer that the descriptors will be\n  recorded in.\n\n* [`Self::descriptor_update_template`] is a descriptor update template defining\n  how to interpret the descriptor information in [`Self::p_data`].\n\n* [`Self::layout`] is a [`crate::vk::PipelineLayout`] object used to program the\n  bindings.\n  It **must** be compatible with the layout used to create the[`Self::descriptor_update_template`] handle.\n\n* [`Self::set`] is the set number of the descriptor set in the pipeline layout\n  that will be updated.\n  This **must** be the same number used to create the[`Self::descriptor_update_template`] handle.\n\n* [`Self::p_data`] is a pointer to memory containing descriptors for the\n  templated update.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-00366  \n   The `pipelineBindPoint` specified during the creation of the\n  descriptor update template **must** be supported by the[`Self::command_buffer`]’s parent [`crate::vk::CommandPool`]’s queue family\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-pData-01686  \n  [`Self::p_data`] **must** be a valid pointer to a memory containing one or more\n  valid instances of [`crate::vk::DescriptorImageInfo`],[`crate::vk::DescriptorBufferInfo`], or [`crate::vk::BufferView`] in a layout defined\n  by [`Self::descriptor_update_template`] when it was created with[`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-descriptorUpdateTemplate-parameter  \n  [`Self::descriptor_update_template`] **must** be a valid [`crate::vk::DescriptorUpdateTemplate`] handle\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-layout-parameter  \n  [`Self::layout`] **must** be a valid [`crate::vk::PipelineLayout`] handle\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics, or compute operations\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commonparent  \n   Each of [`Self::command_buffer`], [`Self::descriptor_update_template`], and [`Self::layout`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Device`]\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |         Graphics  <br/>Compute          |\n\nAPI example\n\n```\nstruct AppDataStructure\n{\n    VkDescriptorImageInfo  imageInfo;          // a single image info\n    // ... some more application related data\n};\n\nconst VkDescriptorUpdateTemplateEntry descriptorUpdateTemplateEntries[] =\n{\n    // binding to a single image descriptor\n    {\n        0,                                           // binding\n        0,                                           // dstArrayElement\n        1,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_COMBINED_IMAGE_SAMPLER,   // descriptorType\n        offsetof(AppDataStructure, imageInfo),       // offset\n        0                                            // stride is not required if descriptorCount is 1\n    }\n};\n\n// create a descriptor update template for push descriptor set updates\nconst VkDescriptorUpdateTemplateCreateInfo createInfo =\n{\n    VK_STRUCTURE_TYPE_DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO,  // sType\n    NULL,                                                      // pNext\n    0,                                                         // flags\n    1,                                                         // descriptorUpdateEntryCount\n    descriptorUpdateTemplateEntries,                           // pDescriptorUpdateEntries\n    VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_PUSH_DESCRIPTORS_KHR,   // templateType\n    0,                                                         // descriptorSetLayout, ignored by given templateType\n    VK_PIPELINE_BIND_POINT_GRAPHICS,                           // pipelineBindPoint\n    myPipelineLayout,                                          // pipelineLayout\n    0,                                                         // set\n};\n\nVkDescriptorUpdateTemplate myDescriptorUpdateTemplate;\nmyResult = vkCreateDescriptorUpdateTemplate(\n    myDevice,\n    &createInfo,\n    NULL,\n    &myDescriptorUpdateTemplate);\n\nAppDataStructure appData;\n// fill appData here or cache it in your engine\nvkCmdPushDescriptorSetWithTemplateKHR(myCmdBuffer, myDescriptorUpdateTemplate, myPipelineLayout, 0,&appData);\n```\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::PipelineLayout`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdPushDescriptorSetWithTemplateKHR = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer, descriptor_update_template: crate::vk1_1::DescriptorUpdateTemplate, layout: crate::vk1_0::PipelineLayout, set: u32, p_data: *const std::ffi::c_void) -> ();
impl<'a> crate::ExtendableFromMut<'a, PhysicalDevicePushDescriptorPropertiesKHR> for crate::vk1_1::PhysicalDeviceProperties2Builder<'a> {}
impl<'a> crate::ExtendableFromMut<'a, PhysicalDevicePushDescriptorPropertiesKHRBuilder<'_>> for crate::vk1_1::PhysicalDeviceProperties2Builder<'a> {}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDevicePushDescriptorPropertiesKHR.html)) · Structure <br/> VkPhysicalDevicePushDescriptorPropertiesKHR - Structure describing push descriptor limits that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDevicePushDescriptorPropertiesKHR`] structure is defined\nas:\n\n```\n// Provided by VK_KHR_push_descriptor\ntypedef struct VkPhysicalDevicePushDescriptorPropertiesKHR {\n    VkStructureType    sType;\n    void*              pNext;\n    uint32_t           maxPushDescriptors;\n} VkPhysicalDevicePushDescriptorPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() [`Self::max_push_descriptors`] is the maximum\n  number of descriptors that **can** be used in a descriptor set created with[`crate::vk::DescriptorSetLayoutCreateFlagBits::PUSH_DESCRIPTOR_KHR`] set.\n[](#_description)Description\n----------\n\nIf the [`crate::vk::PhysicalDevicePushDescriptorPropertiesKHR`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDevicePushDescriptorPropertiesKHR-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_PUSH_DESCRIPTOR_PROPERTIES_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDevicePushDescriptorPropertiesKHR")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct PhysicalDevicePushDescriptorPropertiesKHR {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *mut std::ffi::c_void,
    pub max_push_descriptors: u32,
}
impl PhysicalDevicePushDescriptorPropertiesKHR {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::PHYSICAL_DEVICE_PUSH_DESCRIPTOR_PROPERTIES_KHR;
}
impl Default for PhysicalDevicePushDescriptorPropertiesKHR {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null_mut(), max_push_descriptors: Default::default() }
    }
}
impl std::fmt::Debug for PhysicalDevicePushDescriptorPropertiesKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("PhysicalDevicePushDescriptorPropertiesKHR").field("s_type", &self.s_type).field("p_next", &self.p_next).field("max_push_descriptors", &self.max_push_descriptors).finish()
    }
}
impl PhysicalDevicePushDescriptorPropertiesKHR {
    #[inline]
    pub fn into_builder<'a>(self) -> PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
        PhysicalDevicePushDescriptorPropertiesKHRBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDevicePushDescriptorPropertiesKHR.html)) · Builder of [`PhysicalDevicePushDescriptorPropertiesKHR`] <br/> VkPhysicalDevicePushDescriptorPropertiesKHR - Structure describing push descriptor limits that can be supported by an implementation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDevicePushDescriptorPropertiesKHR`] structure is defined\nas:\n\n```\n// Provided by VK_KHR_push_descriptor\ntypedef struct VkPhysicalDevicePushDescriptorPropertiesKHR {\n    VkStructureType    sType;\n    void*              pNext;\n    uint32_t           maxPushDescriptors;\n} VkPhysicalDevicePushDescriptorPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() [`Self::max_push_descriptors`] is the maximum\n  number of descriptors that **can** be used in a descriptor set created with[`crate::vk::DescriptorSetLayoutCreateFlagBits::PUSH_DESCRIPTOR_KHR`] set.\n[](#_description)Description\n----------\n\nIf the [`crate::vk::PhysicalDevicePushDescriptorPropertiesKHR`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDevicePushDescriptorPropertiesKHR-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_PUSH_DESCRIPTOR_PROPERTIES_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`]\n"]
#[repr(transparent)]
pub struct PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a>(PhysicalDevicePushDescriptorPropertiesKHR, std::marker::PhantomData<&'a ()>);
impl<'a> PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
    #[inline]
    pub fn new() -> PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
        PhysicalDevicePushDescriptorPropertiesKHRBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn max_push_descriptors(mut self, max_push_descriptors: u32) -> Self {
        self.0.max_push_descriptors = max_push_descriptors as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> PhysicalDevicePushDescriptorPropertiesKHR {
        self.0
    }
}
impl<'a> std::default::Default for PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
    fn default() -> PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
    type Target = PhysicalDevicePushDescriptorPropertiesKHR;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for PhysicalDevicePushDescriptorPropertiesKHRBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "Provided by [`crate::extensions::khr_push_descriptor`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdPushDescriptorSetKHR.html)) · Function <br/> vkCmdPushDescriptorSetKHR - Pushes descriptor updates into a command buffer\n[](#_c_specification)C Specification\n----------\n\nIn addition to allocating descriptor sets and binding them to a command\nbuffer, an application **can** record descriptor updates into the command\nbuffer.\n\nTo push descriptor updates into a command buffer, call:\n\n```\n// Provided by VK_KHR_push_descriptor\nvoid vkCmdPushDescriptorSetKHR(\n    VkCommandBuffer                             commandBuffer,\n    VkPipelineBindPoint                         pipelineBindPoint,\n    VkPipelineLayout                            layout,\n    uint32_t                                    set,\n    uint32_t                                    descriptorWriteCount,\n    const VkWriteDescriptorSet*                 pDescriptorWrites);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer that the descriptors will be\n  recorded in.\n\n* [`Self::pipeline_bind_point`] is a [`crate::vk::PipelineBindPoint`] indicating the\n  type of the pipeline that will use the descriptors.\n  There is a separate set of push descriptor bindings for each pipeline\n  type, so binding one does not disturb the others.\n\n* [`Self::layout`] is a [`crate::vk::PipelineLayout`] object used to program the\n  bindings.\n\n* [`Self::set`] is the set number of the descriptor set in the pipeline layout\n  that will be updated.\n\n* [`Self::descriptor_write_count`] is the number of elements in the[`Self::p_descriptor_writes`] array.\n\n* [`Self::p_descriptor_writes`] is a pointer to an array of[`crate::vk::WriteDescriptorSet`] structures describing the descriptors to be\n  updated.\n[](#_description)Description\n----------\n\n*Push descriptors* are a small bank of descriptors whose storage is\ninternally managed by the command buffer rather than being written into a\ndescriptor set and later bound to a command buffer.\nPush descriptors allow for incremental updates of descriptors without\nmanaging the lifetime of descriptor sets.\n\nWhen a command buffer begins recording, all push descriptors are undefined.\nPush descriptors **can** be updated incrementally and cause shaders to use the\nupdated descriptors for subsequent [bound\npipeline commands](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#pipeline-bindpoint-commands) with the pipeline type set by [`Self::pipeline_bind_point`]until the descriptor is overwritten, or else until the set is disturbed as\ndescribed in [Pipeline Layout\nCompatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#descriptorsets-compatibility).\nWhen the set is disturbed or push descriptors with a different descriptor\nset layout are set, all push descriptors are undefined.\n\nPush descriptors that are [statically used](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#shaders-staticuse) by a\npipeline **must** not be undefined at the time that a drawing or dispatching\ncommand is recorded to execute using that pipeline.\nThis includes immutable sampler descriptors, which **must** be pushed before\nthey are accessed by a pipeline (the immutable samplers are pushed, rather\nthan the samplers in [`Self::p_descriptor_writes`]).\nPush descriptors that are not statically used **can** remain undefined.\n\nPush descriptors do not use dynamic offsets.\nInstead, the corresponding non-dynamic descriptor types **can** be used and the`offset` member of [`crate::vk::DescriptorBufferInfo`] **can** be changed each\ntime the descriptor is written.\n\nEach element of [`Self::p_descriptor_writes`] is interpreted as in[`crate::vk::WriteDescriptorSet`], except the `dstSet` member is ignored.\n\nTo push an immutable sampler, use a [`crate::vk::WriteDescriptorSet`] with`dstBinding` and `dstArrayElement` selecting the immutable sampler’s\nbinding.\nIf the descriptor type is [`crate::vk::DescriptorType::SAMPLER`], the`pImageInfo` parameter is ignored and the immutable sampler is taken\nfrom the push descriptor set layout in the pipeline layout.\nIf the descriptor type is [`crate::vk::DescriptorType::COMBINED_IMAGE_SAMPLER`],\nthe `sampler` member of the `pImageInfo` parameter is ignored and\nthe immutable sampler is taken from the push descriptor set layout in the\npipeline layout.\n\nValid Usage\n\n* []() VUID-vkCmdPushDescriptorSetKHR-pipelineBindPoint-00363  \n  [`Self::pipeline_bind_point`] **must** be supported by the [`Self::command_buffer`]’s\n  parent [`crate::vk::CommandPool`]’s queue family\n\n* []() VUID-vkCmdPushDescriptorSetKHR-set-00364  \n  [`Self::set`] **must** be less than[`crate::vk::PipelineLayoutCreateInfo::set_layout_count`] provided when[`Self::layout`] was created\n\n* []() VUID-vkCmdPushDescriptorSetKHR-set-00365  \n  [`Self::set`] **must** be the unique set number in the pipeline layout that\n  uses a descriptor set layout that was created with[`crate::vk::DescriptorSetLayoutCreateFlagBits::PUSH_DESCRIPTOR_KHR`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdPushDescriptorSetKHR-pipelineBindPoint-parameter  \n  [`Self::pipeline_bind_point`] **must** be a valid [`crate::vk::PipelineBindPoint`] value\n\n* []() VUID-vkCmdPushDescriptorSetKHR-layout-parameter  \n  [`Self::layout`] **must** be a valid [`crate::vk::PipelineLayout`] handle\n\n* []() VUID-vkCmdPushDescriptorSetKHR-pDescriptorWrites-parameter  \n  [`Self::p_descriptor_writes`] **must** be a valid pointer to an array of [`Self::descriptor_write_count`] valid [`crate::vk::WriteDescriptorSet`] structures\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics, or compute operations\n\n* []() VUID-vkCmdPushDescriptorSetKHR-descriptorWriteCount-arraylength  \n  [`Self::descriptor_write_count`] **must** be greater than `0`\n\n* []() VUID-vkCmdPushDescriptorSetKHR-commonparent  \n   Both of [`Self::command_buffer`], and [`Self::layout`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Device`]\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |         Graphics  <br/>Compute          |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`], [`crate::vk::PipelineBindPoint`], [`crate::vk::PipelineLayout`], [`crate::vk::WriteDescriptorSet`]\n"]
    #[doc(alias = "vkCmdPushDescriptorSetKHR")]
    pub unsafe fn cmd_push_descriptor_set_khr(&self, command_buffer: crate::vk1_0::CommandBuffer, pipeline_bind_point: crate::vk1_0::PipelineBindPoint, layout: crate::vk1_0::PipelineLayout, set: u32, descriptor_writes: &[crate::vk1_0::WriteDescriptorSetBuilder]) -> () {
        let _function = self.cmd_push_descriptor_set_khr.expect(crate::NOT_LOADED_MESSAGE);
        let descriptor_write_count = descriptor_writes.len();
        let _return = _function(command_buffer as _, pipeline_bind_point as _, layout as _, set as _, descriptor_write_count as _, descriptor_writes.as_ptr() as _);
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdPushDescriptorSetWithTemplateKHR.html)) · Function <br/> vkCmdPushDescriptorSetWithTemplateKHR - Pushes descriptor updates into a command buffer using a descriptor update template\n[](#_c_specification)C Specification\n----------\n\nIt is also possible to use a descriptor update template to specify the push\ndescriptors to update.\nTo do so, call:\n\n```\n// Provided by VK_KHR_push_descriptor with VK_VERSION_1_1, VK_KHR_push_descriptor with VK_KHR_descriptor_update_template, VK_KHR_descriptor_update_template with VK_KHR_push_descriptor\nvoid vkCmdPushDescriptorSetWithTemplateKHR(\n    VkCommandBuffer                             commandBuffer,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    VkPipelineLayout                            layout,\n    uint32_t                                    set,\n    const void*                                 pData);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer that the descriptors will be\n  recorded in.\n\n* [`Self::descriptor_update_template`] is a descriptor update template defining\n  how to interpret the descriptor information in [`Self::p_data`].\n\n* [`Self::layout`] is a [`crate::vk::PipelineLayout`] object used to program the\n  bindings.\n  It **must** be compatible with the layout used to create the[`Self::descriptor_update_template`] handle.\n\n* [`Self::set`] is the set number of the descriptor set in the pipeline layout\n  that will be updated.\n  This **must** be the same number used to create the[`Self::descriptor_update_template`] handle.\n\n* [`Self::p_data`] is a pointer to memory containing descriptors for the\n  templated update.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-00366  \n   The `pipelineBindPoint` specified during the creation of the\n  descriptor update template **must** be supported by the[`Self::command_buffer`]’s parent [`crate::vk::CommandPool`]’s queue family\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-pData-01686  \n  [`Self::p_data`] **must** be a valid pointer to a memory containing one or more\n  valid instances of [`crate::vk::DescriptorImageInfo`],[`crate::vk::DescriptorBufferInfo`], or [`crate::vk::BufferView`] in a layout defined\n  by [`Self::descriptor_update_template`] when it was created with[`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-descriptorUpdateTemplate-parameter  \n  [`Self::descriptor_update_template`] **must** be a valid [`crate::vk::DescriptorUpdateTemplate`] handle\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-layout-parameter  \n  [`Self::layout`] **must** be a valid [`crate::vk::PipelineLayout`] handle\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics, or compute operations\n\n* []() VUID-vkCmdPushDescriptorSetWithTemplateKHR-commonparent  \n   Each of [`Self::command_buffer`], [`Self::descriptor_update_template`], and [`Self::layout`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Device`]\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |         Graphics  <br/>Compute          |\n\nAPI example\n\n```\nstruct AppDataStructure\n{\n    VkDescriptorImageInfo  imageInfo;          // a single image info\n    // ... some more application related data\n};\n\nconst VkDescriptorUpdateTemplateEntry descriptorUpdateTemplateEntries[] =\n{\n    // binding to a single image descriptor\n    {\n        0,                                           // binding\n        0,                                           // dstArrayElement\n        1,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_COMBINED_IMAGE_SAMPLER,   // descriptorType\n        offsetof(AppDataStructure, imageInfo),       // offset\n        0                                            // stride is not required if descriptorCount is 1\n    }\n};\n\n// create a descriptor update template for push descriptor set updates\nconst VkDescriptorUpdateTemplateCreateInfo createInfo =\n{\n    VK_STRUCTURE_TYPE_DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO,  // sType\n    NULL,                                                      // pNext\n    0,                                                         // flags\n    1,                                                         // descriptorUpdateEntryCount\n    descriptorUpdateTemplateEntries,                           // pDescriptorUpdateEntries\n    VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_PUSH_DESCRIPTORS_KHR,   // templateType\n    0,                                                         // descriptorSetLayout, ignored by given templateType\n    VK_PIPELINE_BIND_POINT_GRAPHICS,                           // pipelineBindPoint\n    myPipelineLayout,                                          // pipelineLayout\n    0,                                                         // set\n};\n\nVkDescriptorUpdateTemplate myDescriptorUpdateTemplate;\nmyResult = vkCreateDescriptorUpdateTemplate(\n    myDevice,\n    &createInfo,\n    NULL,\n    &myDescriptorUpdateTemplate);\n\nAppDataStructure appData;\n// fill appData here or cache it in your engine\nvkCmdPushDescriptorSetWithTemplateKHR(myCmdBuffer, myDescriptorUpdateTemplate, myPipelineLayout, 0,&appData);\n```\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::PipelineLayout`]\n"]
    #[doc(alias = "vkCmdPushDescriptorSetWithTemplateKHR")]
    pub unsafe fn cmd_push_descriptor_set_with_template_khr(&self, command_buffer: crate::vk1_0::CommandBuffer, descriptor_update_template: crate::vk1_1::DescriptorUpdateTemplate, layout: crate::vk1_0::PipelineLayout, set: u32, data: *const std::ffi::c_void) -> () {
        let _function = self.cmd_push_descriptor_set_with_template_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(command_buffer as _, descriptor_update_template as _, layout as _, set as _, data);
        ()
    }
}
